#{extends 'border.html'/}
<div class="container-fluid">

    <!-- Toolbar -->
    <div class="row">
        <div class="col-md-12">
            <div class="toolbar">
            </div>
        </div>
    </div>
    <!-- End Toolbar -->

    <div class="row">
        <div class="col-md-12">
        	#{alert /}
            <div class="panel panel-default">
                <div class="panel-body">
                    <form class="api" name="frmInput">
                        <button type="button" class="btn start">&{'mulai.label'}</button>
                        <div class="console">
                            <div class="title">&{'layanan.label'} &{'status.label'}</div>
                            <div class="content">
                                <div class="result" id="result"></div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

#{set 'moreScripts'}
<script src="@{'/public/javascripts/jquery/eventsource/jquery.eventsource.js'}" type="text/javascript"></script>
<script type="text/javascript">
    var winIdList = $(".api");
    var apiResult = winIdList.find(".console .result");
    var frmInput = winIdList.find("form[name=frmInput]");
    var btnStart = winIdList.find(".start");

    var es;

    if(typeof (EventSource) !== "undefined"){
        apiResult.append("Silahkan tekan tombol [Start] untuk memulai.");
        var isEsSupported = true;
    } else {
        apiResult.append("Perhatian!<br />Browser anda tidak mendukung fitur EventSource (HTML 5). Service status akan ditampilkan apabila proses telah selesai 100%.<br /><br />Silahkan tekan tombol [Start] untuk memulai.");
        var isEsSupported = false;
    }

    function startMessage () {

        if (!isEsSupported) {
            $().myAlertDialog({
                title: "<?php echo $this->lang->line('error'); ?>"
                , message: "Internet browser anda tidak mendukung SSE."
            });
            return false;
        }

        btnStart.attr("disabled", true);

        apiResult.empty();
        var url = "@{api.KatalogApiCtr.tes()}";
        es = new EventSource(url);
        es.onmessage = function(e) {
            var isJson = true;
            try {
                var data = $.parseJSON(e.data);
            } catch (err) {
                isJson = false;
            }

            if (!isJson) {
                $().apiStop();
                alert("is not json");
                return;
            }

            if (data.newLine) {
                apiResult.append("<div></div>");
            }
            var div = apiResult.find("div:last");

            if (div.length == 0) {
                var div = apiResult;
            }

            div.append(data.message);
            if (data.suffixWithProgress) {
                div.append(' <span class="smallLoadingBar"></span> ');
            } else {
                div.find(".smallLoadingBar").remove();
            }

            if (data.isEnd) {
                $().apiStop();
            }
        };

    }
    $.fn.apiStop = function() {
        es.close();
        btnStart.button("enable");
    }

    $("body").on("click", ".start", function (e) {
        e.preventDefault();
//        penyediaId = frmInput.find("select[name=penyediaId]").val();
//        tanggalAwal = frmInput.find("input[name=tanggalAwal]").val();
//        tanggalAkhir = frmInput.find("input[name=tanggalAkhir]").val();
        startMessage();
    })
</script>
#{/set}
